<?

use Bitrix\Main\Localization\Loc;
use Bitrix\Main\ModuleManager;
use Bitrix\Main\Config\Option;
use Bitrix\Main\EventManager;
use Bitrix\Main\Application;
use Bitrix\Main\IO\Directory;

Loc::loadMessages(__FILE__);

Class yandexpay_yandexid extends CModule
{

    var $MODULE_ID = "yandexpay.yandexid";
    var $MODULE_VERSION;
    var $MODULE_VERSION_DATE;
    var $MODULE_NAME;
    var $MODULE_DESCRIPTION;
    var $PARTNER_NAME;
    var $PARTNER_URI;

    public function __construct()
    {
        if (is_file(__DIR__.'/version.php')) {
            include(__DIR__.'/version.php');
            $this->MODULE_ID           = "yandexpay.yandexid";
            $this->MODULE_VERSION      = $arModuleVersion['VERSION'];
            $this->MODULE_VERSION_DATE = $arModuleVersion['VERSION_DATE'];
            $this->MODULE_NAME         = Loc::getMessage('MODULE_NAME');
            $this->MODULE_DESCRIPTION  = Loc::getMessage('MODULE_DESCRIPTION');
            $this->PARTNER_NAME = "Yandex";
            $this->PARTNER_URI  = "https://id.ya.ru/";
        } else {
            CAdminMessage::showMessage(
                Loc::getMessage('VERSION_FILE_NOT_FOUND').' version.php'
            );
        }
    }

    public function DoInstall() {

        global $APPLICATION;
        if (CheckVersion(ModuleManager::getVersion('main'), '14.00.00')) {
            $this->installFiles();
            $this->installDB();
            ModuleManager::registerModule($this->MODULE_ID);
            $this->installEvents();
        } else {
            CAdminMessage::showMessage(
                Loc::getMessage('MODULE_INSTALL_ERROR')
            );
            return;
        }

        $APPLICATION->includeAdminFile(
            Loc::getMessage('MODULE_INSTALL_TITLE').' «'.Loc::getMessage('MODULE_NAME').'»',
            __DIR__.'/step.php'
        );
    }
    
    public function installFiles() {
        CopyDirFiles(
            __DIR__.'/yandexid',
            Application::getDocumentRoot() .'/yandexid/',
            true,
            true
        );
        CopyDirFiles(
            __DIR__.'/themes',
            Application::getDocumentRoot() .'/bitrix/themes',
            true,
            true
        );
    }
    
    public function installDB() {
        return;
    }

    public function installEvents() {
        EventManager::getInstance()->registerEventHandler(
            'main',
            'OnProlog',
            $this->MODULE_ID,
            'YandexID',
            'appendJavaScript'
        );
    }

    public function DoUninstall() {

        global $APPLICATION;

        $this->uninstallFiles();
        $this->uninstallDB();
        $this->uninstallEvents();

        ModuleManager::unRegisterModule($this->MODULE_ID);

        $APPLICATION->includeAdminFile(
            Loc::getMessage('MODULE_UNINSTALL_TITLE').' «'.Loc::getMessage('MODULE_NAME').'»',
            __DIR__.'/unstep.php'
        );

    }

    public function uninstallFiles() {
        Directory::deleteDirectory(
            Application::getDocumentRoot().'/yandexid'
        );
        Directory::deleteDirectory(
            Application::getDocumentRoot().'/bitrix/themes/.default/images/yandexpay.yandexid/'
        );
        Option::delete($this->MODULE_ID);
    }
    
    public function uninstallDB() {
        return;
    }
    
    public function uninstallEvents() {
        EventManager::getInstance()->unRegisterEventHandler(
            'main',
            'OnProlog',
            $this->MODULE_ID,
            'YandexID',
            'appendJavaScript'
        );
    }
}