<?
use Bitrix\Main;
use Bitrix\Main\Config\Option;
use Bitrix\Main\Page\Asset;

class YandexID
{
  public static function appendJavaScript()
  {
    $module_id = pathinfo(dirname(__DIR__))['basename'];

    if (!defined('ADMIN_SECTION')) {
      if (Option::get($module_id, 'yandexid_on', 'N', SITE_ID) == 'Y') {
        global $USER;
        if (!$USER->IsAuthorized()) {
          $client_id = Option::get($module_id, 'yandexid_app_client_id', '', SITE_ID);

          if(!empty($client_id)) {
            Asset::getInstance()->addJs('https://yastatic.net/s3/passport-sdk/autofill/v1/sdk-suggest-with-polyfills-latest.js');

            $script = '<script>window.addEventListener("load", function(event) {';

            $callbackUrlExist = Option::get($module_id, 'yandexid_domain', '', SITE_ID);
            $callbackUrl = !empty($callbackUrlExist) ? $callbackUrlExist : $_SERVER['HTTP_HOST'];

            $script .= 'let tokenPageOrigin = "'.(CMain::IsHTTPS() ? "https://" : "http://") . $callbackUrl . '";';
            $script .= 'let oauthQueryParams = {client_id: "'.$client_id.'", response_type: "token",redirect_uri: "'.(CMain::IsHTTPS() ? "https://" : "http://") . $callbackUrl . '/yandexid/oauth.php'.'"};';

            $script .= 'function authorizationUser(o){console.log(o);let t="/yandexid/auth.php";fetch(t=t+"?action=ajax_authorization_user&access_token="+o,{method:"GET",headers:{"Content-Type":"application/json"}}).then(o=>o.json()).then(o=>{console.log(o),!1==o.error&&(window.location.href="'.$_SERVER["REQUEST_URI"].'")}).catch(o=>console.log("error",o))}';

            if(Option::get($module_id, 'yandexid_type_selection', 'widget') == 'widget') {
              
              $script .= 'window.YaAuthSuggest.init(oauthQueryParams,tokenPageOrigin).then(function(n){return n.handler()}).then(function(n){authorizationUser(n.access_token),console.log("Сообщение с токеном: ",n)}).catch(function(n){console.log("Что-то пошло не так: ",n)});';
            } else {

              $params = array();
              $params['view'] = "button";
              $parentExist = false;
              if(!empty(Option::get($module_id, 'suggest_parent_id', '', SITE_ID))) {
                $params['parentId'] = Option::get($module_id, 'suggest_parent_id', '', SITE_ID);
                $parentExist = true;
              }

              if(!empty(Option::get($module_id, 'suggest_button_view', '', SITE_ID))) {
                $params['buttonView'] = Option::get($module_id, 'suggest_button_view', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_button_theme', '', SITE_ID))) {
                $params['buttonTheme'] = Option::get($module_id, 'suggest_button_theme', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_button_size', '', SITE_ID))) {
                $params['buttonSize'] = Option::get($module_id, 'suggest_button_size', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_button_border_radius', '', SITE_ID))) {
                $params['buttonBorderRadius'] = Option::get($module_id, 'suggest_button_border_radius', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_color_bg_base', '', SITE_ID))) {
                $params['customBgColor'] = Option::get($module_id, 'suggest_color_bg_base', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_color_bg_hovered', '', SITE_ID))) {
                $params['customBgHoveredColor'] = Option::get($module_id, 'suggest_color_bg_hovered', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_color_border_base', '', SITE_ID))) {
                $params['customBorderColor'] = Option::get($module_id, 'suggest_color_border_base', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_color_border_hovered', '', SITE_ID))) {
                $params['customBorderHoveredColor '] = Option::get($module_id, 'suggest_color_border_hovered', '', SITE_ID);
              }

              if(!empty(Option::get($module_id, 'suggest_border_thickness', '', SITE_ID))) {
                $params['customBorderWidth '] = Option::get($module_id, 'suggest_border_thickness', '', SITE_ID);
              }


              $script .= 'let suggestParams = '.json_encode($params).';';
              if($parentExist) {
                $script .= 'if(!!document.getElementById("'.$params['parentId'].'")){';
              }
              $script .= 'window.YaAuthSuggest.init(oauthQueryParams,tokenPageOrigin,suggestParams).then(function(n){return n.handler()}).then(function(n){authorizationUser(n.access_token),console.log("Сообщение с токеном: ",n)}).catch(function(n){console.log("Что-то пошло не так: ",n)});';
              if($parentExist) {
                $script .= '}'; 
              }
            }
            $script .= '})</script>';

            Asset::getInstance()->addString($script, true);
          }
        }
      }
    }
  }

  public static function authUser($token = '') {
    if(!empty($token)) {
      require_once(__DIR__ . '/YandexAPI.php');
      $YandexApi = new YandexApi();

      $result = $YandexApi->getUserInfo($token);

      $email = $result['default_email'];

      if(empty($email)) {
        echo json_encode([
          'error' => true,
          'message' => 'Невозможно авторизовать пользователя. Войдите в аккаунт с email'
        ]);
        die();
      }

      $module_id = pathinfo(dirname(__DIR__))['basename'];

      global $USER;
      $rsUser = CUser::GetByLogin($email);
      if($arUser = $rsUser->Fetch()) {
        $USER->Authorize($arUser['ID']);
      } else {
        $rsUsers = CUser::GetList(($by="id"), ($order="desc"), array('EMAIL' => $email));

        if($arUser = $rsUsers->Fetch()){
          $USER->Authorize($arUser['ID']);
        } else {
          $user = new CUser;

          $password = self::rand_string(8);
          $groupId = Option::get($module_id, 'yandexid_role', '2', SITE_ID);

          $arFileds = array(
            'LOGIN' => $email,
            'EMAIL' => $email,
            'ACTIVE' => 'Y',
            'PASSWORD' => $password,
            'CONFIRM_PASSWORD' => $password,
            'GROUP_ID' => array($groupId)
          );

          if(isset($result['first_name'])) {
            $arFileds['NAME'] = $result['first_name'];
          }

          if(isset($result['last_name'])) {
            $arFileds['LAST_NAME'] = $result['last_name'];
          }

          if(isset($result['default_phone']) && !empty($result['default_phone'])) {
            $arFileds['PERSONAL_PHONE'] = $result['default_phone']['number'];

            $phoneRegistration = (Option::get('main', 'new_user_phone_auth', 'N', SITE_ID) == 'Y');
            if($phoneRegistration && Option::get('main', 'new_user_phone_required', 'N', SITE_ID) == 'Y') {
              $arFileds['PHONE_NUMBER'] = $result['default_phone']['number'];
            }
          }

          if(isset($result['birthday'])) {
            $phpDate = new DateTime($result['birthday']);

            $date = Bitrix\Main\Type\Date::createFromPhp($phpDate);

            if($date instanceof Bitrix\Main\Type\Date) {
              $arFileds['PERSONAL_BIRTHDAY'] = $date->toString();
            }
          }

          // if(isset($result['login'])) {
          //   $arFileds['LOGIN'] = $result['login'];
          // }

          if(isset($result['sex']) && !empty($result['sex'])) {
            $arFileds['PERSONAL_GENDER'] = ($result['sex'] == 'male') ? 'M' : 'F';
          }

          $ID = $user->Add(
            $arFileds
          );

          if (intval($ID) > 0) {
            $USER->Authorize($ID);
          } else {
            echo json_encode([
              'error' => true,
              'message' => $user->LAST_ERROR
            ]);
            die();
          }
        }
      }
      echo json_encode([
      'error' => false
      ]);
    } else {
      echo json_encode([
        'error' => true,
        'message' => 'Передан пустой токен'
      ]);
    }
  }

  private static function rand_string( $length ) {
    $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    $specials = "!@#$%^&*()";
    $numbers = "0123456789";
    
    $charactersLength = strlen($chars);
    $randomString = '';
    for ($i = 0; $i < $length - 2; $i++) {
        $randomString .= $chars[rand(0, $charactersLength - 1)];
    }
    $randomString .= $specials[rand(0, strlen($specials) - 1)];
    $randomString .= $numbers[rand(0, strlen($numbers) - 1)];
    return str_shuffle($randomString);
  }
}