<?php
/**
 * Yandex ID - API
 */
 

class YandexApi{
  
  private $oauth_url = 'https://oauth.yandex.ru';
  private $login_url = 'https://login.yandex.ru/info?format=json';
  private $token_url = 'https://yandex-id.outcode.ru/';
  
  public function __construct(){
    
    //throw new Exception('...'); 
  }
  
  /**
   *      API
   *
  */
  public function getToken() { 
    
    if (function_exists('curl_version')) {

      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, $this->token_url);
      curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_FAILONERROR, true);
      curl_setopt($curl, CURLOPT_POST, false);    

      $out = curl_exec($curl);
      $errosMsg = curl_error($curl);
      curl_close($curl);
      
      $result = json_decode($out, true);

      if(isset($result['access_token'])){
        return $result;
      } elseif(!empty($errosMsg)){
        return ['error' => $errosMsg];
      }
      
      return ['error' => '    CURL'];

    } else{
      throw new Exception('cURL -  ');
    }     
  }
  
 
  /**
   *  oAuth 
   *
  */
  public function createOauthApp($oauth_token, $data) { 

    if (function_exists('curl_version')) {

      $curl = curl_init();
      $scopes = $data['scopes'];
      $redirect_uris = $data['redirect_uris'];
      unset($data['scopes'], $data['redirect_uris']);

      $query = http_build_query($data);
      $query .= '&scopes='.$scopes;
      $query .= '&redirect_uris='.$redirect_uris;
      
      $debug = [
        'oauth_token' => $oauth_token,
        'data' => $data,
        'query' => $query
      ];

      curl_setopt($curl, CURLOPT_URL, $this->oauth_url.'/api/1/client/create/external');
      curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_POST, true);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $query);
      curl_setopt($curl, CURLOPT_HTTPHEADER, array(
          //'Content-Type: application/x-www-form-urlencoded',
          'Authorization:'.'oAuth '.$oauth_token
      ));    

      $out = curl_exec($curl);
      curl_close($curl);
      
      $debug['raw'] = $out;
      
      $result = json_decode($out, true);

      if(isset($result['client_id']) && isset($result['client_secret'])){
        return $result;
      }
      
      return [];

    }else{
      throw new Exception('cURL -  ');
    }     
  }
  
  /**
   *  oAuth 
   *
  */
  public function editOauthApp($oauth_token, $data) { 

    if (function_exists('curl_version')) {

      $curl = curl_init();
      $scopes = $data['scopes'];
      $redirect_uris = $data['redirect_uris'];
      unset($data['scopes'], $data['redirect_uris']);

      $query = http_build_query($data);
      $query .= '&scopes='.$scopes;
      $query .= '&redirect_uris='.$redirect_uris;
      
      $debug = [
        'oauth_token' => $oauth_token,
        'data' => $data,
        'query' => $query
      ];

      curl_setopt($curl, CURLOPT_URL, $this->oauth_url.'/api/1/client/edit/external');
      curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
      curl_setopt($curl, CURLOPT_POST, true);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $query);
      curl_setopt($curl, CURLOPT_HTTPHEADER, array(
          'Authorization:'.'oAuth '.$oauth_token
      ));    

      $out = curl_exec($curl);
      curl_close($curl);
      
      $debug['raw'] = $out;
      
      $result = json_decode($out,true);

      if(isset($result['status']) && $result['status'] == 'ok'){
        return true;
      }
      
      return false;

    }else{
      throw new Exception('cURL -  ');
    }     
  }
  
  /**
    *   
   *
  */  
  public function getUserInfo($oauth_token){
  
  
      $debug = [
        'oauth_token' => $oauth_token
      ];  
  
  
    if (function_exists('curl_version')) {
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_URL, $this->login_url);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($curl, CURLOPT_HTTPHEADER, [
        'Authorization:'.'oAuth '.$oauth_token
      ]);

      $out = curl_exec($curl);
      curl_close($curl);
      
      $result = json_decode($out, true);
      
      if(!empty($result)){
        return $result;
      }
      
      return null;

    }else{
      throw new Exception('cURL -  ');
    }
  
  }  
  
  
  public function logs($type, $data){
    $file = __DIR__.'/debug_'.$type.'.txt';
    $current = var_export($data, true);
    file_put_contents($file, $current);   
  }
}