<?

use Bitrix\Main\Localization\Loc;
use Bitrix\Main\HttpApplication;
use Bitrix\Main\Loader;
use Bitrix\Main\Config\Option;
use Bitrix\Main;

Loc::loadMessages(__FILE__);

$request = HttpApplication::getInstance()->getContext()->getRequest();
$module_id = htmlspecialchars($request['mid'] != '' ? $request['mid'] : $request['id']);
Loader::includeModule($module_id);

$SITE_ID = 's1';
$sites = [];
$rsSites = CSite::GetList($by="sort", $order="desc", Array());
while ($arSite = $rsSites->Fetch())
{
  $sitesArr = trim($arSite['DOMAINS']);
  $sitesArr = explode("\n", $sitesArr);
  $sitesArr = array_map('trim', $sitesArr);

  foreach($sitesArr as $site) {
    $site = !empty(parse_url($site, PHP_URL_HOST)) ? parse_url($site, PHP_URL_HOST) : $site;
    if ($site == $_SERVER['SERVER_NAME']) {
      $SITE_ID = $arSite['ID'];
      $sites = $sitesArr;
      break 2;
    }
  }
}

$groups = array();
$rsGroups = CGroup::GetList(($by="id"), ($order="asc"), array());
if(intval($rsGroups->SelectedRowsCount()) > 0)
{
   while($arGroups = $rsGroups->Fetch())
   {
      $groups[$arGroups['ID']] = $arGroups['NAME'];
   }
}

$aTabs = array(
  array(
    'DIV'     => 'edit1',
    'TAB'     => 'Настройки модуля для сайта ' . $SITE_ID,
    'TITLE'   => 'Настройки модуля для сайта ' . $SITE_ID,
    'OPTIONS' => array(
      'yandexid_on_row' => array(
        'yandexid_on',
        'Включить модуль', //LOC
        'N',
        array('checkbox')
      ),
      'yandexid_title' => array(
        'yandexid_title',
        'Название приложения', //LOC
        '',
        array('text', 40),
        '<div>Название приложения будет показано пользователю <br>при авторизации. <a target="_blank" href="/bitrix/themes/.default/images/'. $module_id .'/app-title.jpg">Посмотреть пример</a></div>'
      ),
      'yandexid_type_selection' => array(
        'yandexid_type_selection',
        'Блок авторизации', // LOC
        'button',
        array(
            'selectbox',
            array(
                'widget'  => 'Виджет «Мгновенный вход»', //LOC
                'button' => 'Кнопка авторизации' // LOC
            )
        ),
        '<div>Виджет «Мгновенный вход» -  <a target="_blank" href="/bitrix/themes/.default/images/'. $module_id .'/widget.jpg">Пример</a><br>Кнопка авторизации -  <a target="_blank" href="/bitrix/themes/.default/images/'. $module_id .'/button.jpg">Пример</a><br></div>'
      ),
      'yandexid_role' => array(
        'yandexid_role',
        'Применяемая группа при создании пользователя', // LOC
        '2',
        array(
            'selectbox',
            $groups
        )
      ),
      "user_data" => "Запрашиваемые данные пользователя", //LOC
      'scope_login_info_row' => array(
        'scope_login_info',
        'Доступ к имени и фамилии, полу', //LOC
        'N',
        array('checkbox')
      ),
      'scope_login_default_phone_row' => array(
        'scope_login_default_phone',
        'Доступ к номеру телефона', //LOC
        'N',
        array('checkbox')
      ),
      'scope_login_birthday_row' => array(
        'scope_login_birthday',
        'Доступ к дате рождения', //LOC
        'N',
        array('checkbox')
      ),
      "button_style" => "Настройки внешнего вида для кнопки авторизации", //LOC
      "suggest_button_view" => array(
        "suggest_button_view",
        "Тип кнопки",
        'main',
        array(
          'selectbox',
          array(
            'main' => 'Основная версия',
            'additional' => 'Основная версия с контрастной обводкой',
            'icon' => 'Кнопка-иконка с логотипом Яндекса',
            'iconGrey' => 'Серая кнопка-иконка с логотипом Яндекса',
            'iconBorder' => 'Белая кнопка-иконка с логотипом Яндекса и черной обводкой по периметру'
          )
        ),
        '<div id="btn_prw"></div>'
      ),
      'suggest_parent_id' => array(
        'suggest_parent_id',
        'Значение id атрибута контейнера, в который нужно встроить кнопку', //LOC
        '',
        array('text', 40)
      ),
      'suggest_button_border_radius' => array(
        'suggest_button_border_radius',
        'Радиус скругления границ кнопки', //LOC
        '4',
        array('text', 5)
      ),
      'suggest_button_theme' => array(
        'suggest_button_theme',
        'Тема кнопки', // LOC
        'dark',
        array(
            'selectbox',
            array(
                'light'  => 'Светлая тема', //LOC
                'dark' => 'Темная тема' // LOC
            )
        )
      ),
      'suggest_button_size' => array(
        'suggest_button_size',
        'Размер кнопки', // LOC
        'xs',
        array(
            'selectbox',
            array(
                'xs'  => 'XS',
                's' => 'S',
                'm' => 'M',
                'l' => 'L',
                'xl' => 'XL',
                'XXL' => 'XXL'
            )
        )
      ),
      'suggest_color_bg_base' => array(
        'suggest_color_bg_base',
        'Цвет фона подложки', //LOC
        '',
        array('text', 10)
      ),
      'suggest_color_bg_hovered' => array(
        'suggest_color_bg_hovered',
        'Цвет фона подложки под курсором', //LOC
        '',
        array('text', 10)
      ),
      'suggest_color_border_base' => array(
        'suggest_color_border_base',
        'Цвет обводки', //LOC
        '',
        array('text', 10)
      ),
      'suggest_color_border_hovered' => array(
        'suggest_color_border_hovered',
        'Цвет обводки под курсором', //LOC
        '',
        array('text', 10)
      ),
      'suggest_border_thickness' => array(
        'suggest_border_thickness',
        'Толщина обводки', //LOC
        '',
        array('text', 4)
      ),
      "special_props" => "Специальные настройки", //LOC
      'yandexid_domain' => array(
        'yandexid_domain',
        'Домен для получения коллбека', //LOC
        '',
        array('text', 40),
        '<div>Если вы хотите использовать отличный от основного домен для получения коллбека, то укажите его (без https://)</div>'
      ),
    )
  )
);

if ($request->isPost() && check_bitrix_sessid()) {

  foreach ($aTabs as $aTab) {
      foreach ($aTab['OPTIONS'] as $arOption) {
          if (!is_array($arOption)) {
              continue;
          }
          if ($arOption['note']) {
              continue;
          }

          $optionValue = $request->getPost($arOption[0]);
          if (in_array($arOption[0], array('yandexid_on', 'scope_login_birthday', 'scope_login_info', 'scope_login_default_phone'))) {
              if ($optionValue == '') {
                  $optionValue = 'N';
              }
          }

          if ($arOption[0] == 'yandexid_title') {
              if ($optionValue == '') {
                  $optionValue = $_SERVER['HTTP_HOST'] . '-YandexIDApp';
              }
          }


          Option::set($module_id, $arOption[0], is_array($optionValue) ? implode(',', $optionValue) : $optionValue, $SITE_ID);

      }
  }

  require_once(__DIR__ . '/lib/YandexAPI.php');

  $oauth_token = Option::get($module_id, 'yandexid_oauth_token', '', $SITE_ID);
  $expires_in = Option::get($module_id, 'yandexid_expires_oauth_token', 0, $SITE_ID);

  $errors = 0;

  $expires_in = ($expires_in == false) ? 0 : $expires_in;

  $YandexApi = new YandexApi();

  if(empty($oauth_token) || $expires_in <= time()){
    $result = $YandexApi->getToken();
    
    if(!isset($result['error'])){
      $oauth_token = $result['access_token'];
      $expires_in = time() + $result['expires_in'];

      Option::set($module_id, 'yandexid_oauth_token', $oauth_token, $SITE_ID);
      Option::set($module_id, 'yandexid_expires_oauth_token', $expires_in, $SITE_ID);
    } else {
      CAdminMessage::ShowMessage("Ошибка при получении токена. " . $result['error']);
      $errors++;
    }
  }

  if(!empty($oauth_token) && $expires_in > time()) {
    $client_id = Option::get($module_id, 'yandexid_app_client_id', '', $SITE_ID);

    $data = array(
      'title' => Option::get($module_id, 'yandexid_title', '', $SITE_ID),
      'scopes' => __getScopes($module_id, $SITE_ID),
      'platforms' => 'web'
    );
  
    $callbackUrl = Option::get($module_id, 'yandexid_domain', '', $SITE_ID);

    if(empty($callbackUrl)) {
      if(empty($sites)) {
        $data['redirect_uris'] = (CMain::IsHTTPS() ? "https://" : "http://") . $_SERVER['HTTP_HOST'] . '/yandexid/oauth.php';
      } else {
        $redirect_uris = [];
        foreach ($sites as $domain) {
          $redirect_uris[] = (CMain::IsHTTPS() ? "https://" : "http://") . (!empty(parse_url($domain, PHP_URL_HOST)) ? parse_url($domain, PHP_URL_HOST) : $domain) . '/yandexid/oauth.php';
        }
        $data['redirect_uris'] = implode('&redirect_uris=', $redirect_uris);
      }
    } else {
      $data['redirect_uris'] = (CMain::IsHTTPS() ? "https://" : "http://") . $callbackUrl . '/yandexid/oauth.php';
    }

    if(empty($client_id)) {
      $result = $YandexApi->createOauthApp($oauth_token, $data);
    
      if(!empty($result)) {
        $client_id = $result['client_id'];

        Option::set($module_id, 'yandexid_app_client_id', $client_id, $SITE_ID);
        Option::set($module_id, 'yandexid_app_client_secret', $result['client_secret'], $SITE_ID);
      } else {
        CAdminMessage::ShowMessage("Ошибка при создании приложения");
        $errors++;
      }
    } else {
      $data['client_id'] = $client_id;
      $result = $YandexApi->editOauthApp($oauth_token, $data);
      
      if($result === false){
        CAdminMessage::ShowMessage("Ошибка при редактировании приложения");
        $errors++;
      }
    }
  }

  if($errors === 0){
    CAdminMessage::ShowNote("Настройки сохранены");
  }
}


$tabControl = new CAdminTabControl(
    'tabControl',
    $aTabs
);

function __getScopes($module_id, $SITE_ID) {
  $options = [
    'scope_login_info' => 'login:info',
    'scope_login_default_phone' => 'login:default_phone',
    'scope_login_birthday' => 'login:birthday'
  ];  
  
  $result = array('login:email');
  
  foreach($options as $option => $scope){
    $value = Option::get($module_id, $option, "N", $SITE_ID);
    
    if($value == 'Y'){
      $result[] = $scope;
    }
  }

  return implode('&scopes=', $result);
}

function __YandexSettingsDrawRow($module_id, $Option, $id = "", $SITE_ID = "s1")
{
  $arControllerOption = CControllerClient::GetInstalledOptions($module_id);
  if($Option === null)
  {
    return;
  }

  if(!is_array($Option)):
  ?>
    <tr class="heading" id="<?=$id ?>">
      <td colspan="2"><?=$Option?></td>
    </tr>
  <?
  elseif(isset($Option["note"])):
  ?>
    <tr id="<?=$id ?>">
      <td colspan="2" align="center">
        <?echo BeginNote('align="center"');?>
        <?=$Option["note"]?>
        <?echo EndNote();?>
      </td>
    </tr>
  <?
  else:
    $isChoiceSites = array_key_exists(4, $Option) && !empty($Option[4]) ? true : false;
    $listSite = array();
    $listSiteValue = array();
    $val = Option::get($module_id, $Option[0], $Option[2], $SITE_ID);
  ?>
      <tr id="<?=$id ?>">
        <?
          renderLable($Option, $listSite);
          renderInput($Option, $arControllerOption, $Option[0], $val);
        ?>
      </tr>
    <? if ($isChoiceSites): ?>
      <tr id="<?=$id ?>_desc">
        <td width="50%"></td>
        <td width="50%">
          <?=$Option[4]?>
        </td>
      </tr>
    <? endif; ?>
  <?
  endif;
}

function __YandexSettingsDrawList($module_id, $arParams, $SITE_ID)
{
  foreach($arParams as $id => $Option)
  {
    __YandexSettingsDrawRow($module_id, $Option, $id, $SITE_ID);
  }
}

$tabControl->begin();

$isCurlExist = function_exists('curl_version');
$isHttps = CMain::IsHTTPS();

$SITE_ID = 's1';
$rsSites = CSite::GetList($by="sort", $order="desc", Array());
while ($arSite = $rsSites->Fetch())
{
  $sitesArr = trim($arSite['DOMAINS']);
  $sitesArr = explode("\n", $sitesArr);
  $sitesArr = array_map('trim', $sitesArr);

  foreach($sitesArr as $site) {
    $site = !empty(parse_url($site, PHP_URL_HOST)) ? parse_url($site, PHP_URL_HOST) : $site;
    if ($site == $_SERVER['SERVER_NAME']) {
      $SITE_ID = $arSite['ID'];
      break 2;
    }
  }
}

?>
<form action="<?= $APPLICATION->getCurPage(); ?>?mid=<?=$module_id; ?>&lang=<?= LANGUAGE_ID; ?>" method="post">
    <?= bitrix_sessid_post(); ?>
    <?php
    foreach ($aTabs as $aTab) {
        if ($aTab['OPTIONS']) {
            $tabControl->beginNextTab();
            __YandexSettingsDrawList($module_id, $aTab['OPTIONS'], $SITE_ID);
        }
    }
    $tabControl->buttons();
    ?>
    <input type="submit" name="apply" 
           value="Сохранить" class="adm-btn-save"<?=(!$isCurlExist) ? ' disabled' : ''?> />

    <? if(!$isCurlExist) {?>
      <p style="color: red; margin: 16px 0 0;">Библиотека CURL не установлена</p>
    <? } ?>
    <? if(!$isHttps) {?>
      <p style="color: red; margin: 16px 0 0;">Вы используете небезопасное подлючение по HTTP</p>
      <p style="color: #545454; margin: 8px 0 0; font-size: 12px;">Для корректной интеграции необходим защищённый протокол передачи данных в интернете HTTPS</p>
    <? } ?>
</form>
<script>
  function checkVisibleFields(){
    var hiddenFieldsByType = [
      "button_style", "suggest_button_view", "suggest_button_view_desc", "suggest_parent_id", "suggest_button_border_radius", "suggest_button_theme", "suggest_button_size", "suggest_color_bg_base", "suggest_color_bg_hovered", "suggest_color_border_base", "suggest_color_border_hovered", "suggest_border_thickness"
    ];
    if(document.querySelector('select[name="yandexid_type_selection"]').value !== 'button') {
      hiddenFieldsByType.forEach(function(element){
        document.getElementById(element).style.height = 0;
        document.getElementById(element).style.overflow = 'hidden';
        document.getElementById(element).style.display = 'block';
      });
    } else {
      hiddenFieldsByType.forEach(function(element){
        document.getElementById(element).style.height = 'auto';
        document.getElementById(element).style.overflow = 'visible';
        document.getElementById(element).style.display = 'table-row';
      });

      var hiddenFieldsByButtonType = [
        "suggest_color_bg_base", "suggest_color_bg_hovered", "suggest_color_border_base", "suggest_color_border_hovered", "suggest_border_thickness"
      ];

      if(document.querySelector('select[name="suggest_button_view"]').value !== 'iconGrey' && document.querySelector('select[name="suggest_button_view"]').value !== 'iconBorder') {
        hiddenFieldsByButtonType.forEach(function(element){
          document.getElementById(element).style.height = 0;
          document.getElementById(element).style.overflow = 'hidden';
          document.getElementById(element).style.display = 'block';
        });
      } else {
        hiddenFieldsByButtonType.forEach(function(element){
          document.getElementById(element).style.height = 'auto';
          document.getElementById(element).style.overflow = 'visible';
          document.getElementById(element).style.display = 'table-row';
        });
      }

      var imgPath = '/bitrix/themes/.default/images/<?=$module_id ?>/btn/',
          view = document.querySelector('select[name="suggest_button_view"]').value,
          theme = (view == 'additional' || view == 'main') ? '-' + document.querySelector('select[name="suggest_button_theme"]').value : '';

      document.getElementById("btn_prw").innerHTML = '<img src="' + imgPath + view + theme + '.jpg" alt="" style="width: auto; height: 100px;" />';
    }
  }
  
  checkVisibleFields();

  document.querySelector('select[name="yandexid_type_selection"]').addEventListener('change', function() {
    checkVisibleFields();
  });

  document.querySelector('select[name="suggest_button_view"]').addEventListener('change', function() {
    checkVisibleFields();
  });

  document.querySelector('select[name="suggest_button_theme"]').addEventListener('change', function() {
    checkVisibleFields();
  });

</script>
<?php
$tabControl->end();

?>